/*
Copyright 2005 Midnight Coders, LLC

Licensed under the Midnight Coders license (the "License");
You may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.themidnightcoders.com/licensing/asdklicense.htm

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

import asdk.*;
import asdk.condition.*;
import asdk.iterator.*;

class asdk.condition.BinaryAnd implements BinaryCondition
{
	private var conditions : Array;
	
    // condition1 may be an array of other unary expressions
	// condition2 is optional and must be an intance of BinaryCondition
	function BinaryAnd( condition1, condition2 : BinaryCondition )
	{
        if( condition1 instanceof BinaryCondition )
		{
            this.conditions = new Array();
            this.conditions.push( condition1 );
            this.conditions.push( condition2 );
		}
		else
		{
            this.conditions = condition1;
		}
	}
	
	function execute( operandA, operandB ) : Boolean
	{
        var arrayIterator : Iterator = new ArrayIterator( conditions );
		
		while( arrayIterator.hasNext() )
			if( !arrayIterator.getNext().execute( operandA, operandB ) )
			  return false;
		
		return true;
	}	
}