/*
Copyright 2005 Midnight Coders, LLC

Licensed under the Midnight Coders license (the "License");
You may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.themidnightcoders.com/licensing/asdklicense.htm

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

import asdk.condition.*;
import asdk.functions.*;

class asdk.condition.BinaryCompositeCondition implements BinaryCondition
{
	private var condition : BinaryCondition;
	private var function1 : UnaryFunction;
	private var function2 : UnaryFunction;
	
	function BinaryCompositeCondition( condition : BinaryCondition, function1 : UnaryFunction, function2 : UnaryFunction )
	{
		this.condition = condition;
		this.function1 = function1;
		this.function2 = function2;
	}
	
	function execute( operandA, operandB ) : Boolean
	{
		return condition.execute( function1.execute( operandA ), function2.execute( operandB ) );
	}
}
