/*
Copyright 2005 Midnight Coders, LLC

Licensed under the Midnight Coders license (the "License");
You may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.themidnightcoders.com/licensing/asdklicense.htm

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

import asdk.functions.*;
import asdk.condition.*;

class asdk.functions.BinaryCompose implements BinaryFunction
{
    var binaryFunction:BinaryFunction;
    var function1:UnaryFunction;
    var function2:UnaryFunction;
    
    function BinaryCompose( binaryFunction:BinaryFunction, function1:UnaryFunction , function2:UnaryFunction )
    {
        this.binaryFunction = binaryFunction;
        this.function1 = function1;
        this.function2 = function2;
    }
    
	function execute( operand1, operand2 )
    {
        return binaryFunction.execute( function1.execute( operand1), function2.execute( operand2 ) );
    }
}