/**
* Interface ISystemProcess
* This inteface should be implemented by classes that works as System Processes.
* It provides basic standard Process methods to loose couple between the processes and the FWASystem class
* 
* @author		Federico Campo Piombi [federicocp@htomail.com]
* @version		1.0
* @date			14 Nov 2006
* 
* @see			com.fwa.system.FWASystem
*/
interface com.fwa.system.processes.ISystemProcess {
	
	public function init():Void
	
	public function toString():String
	
	//System Process Events:
	public function onProcessStarted(total_subprocesses:Number):Void
	
	public function onProcessUpdated(current_subprocess:Number, total_subprocesses:Number):Void
	
	public function onProcessCompleted():Void
	
	public function onProcessAborted(reason:String):Void
}