import com.fwa.system.FWAConfiguration;
import com.fwa.ui.Window;
import com.fwa.ui.Windows;

/**
* Static class Application
* This class provides access to basic Application control and data retrieving methods.
* 
* @version 	1.3
* @since 	30 Nov 2006
* 
* @ignore
* MODIFICATION HISTORY
* 
* 1.1 - 17 Dec 2006
* + Added "setListener"
* + Added "var listener"
* 
* 1.2 - 13 Mar 2007
* + Removed loadDefault, setDefault
* + renamed "open" to "load"
* + added new "open" method
* 
* 1.3 - 17 Mar 2007
* + removed "open" method
* + modified "load" method to load an
*   app according to the FWAConfiguration params
*/
class com.fwaapi.Application {
	//PROPERTIES
	private static var listener:Object; //object with preload listening functions
	
	/**
	* Constructor
	*/
	private function Application(){};
	
	
	/**
	* Loads the application according to the FWAConfiguration values
	* FWAConfiguration.application and FWAConfiguration.applicationfile
	* @return	Void
	*/
	public static function load():Void {
		var path:String = FWAConfiguration.application;
		var file:String = FWAConfiguration.applicationfile;
		var appconfig:Object = {filename:path+file, modal:false, identifier:"app"}
		var wndMGR:Windows = Windows.getInstance()
		var wnd_app:Window = wndMGR.open("__APPLICATION", appconfig)
		wnd_app.addListener(listener);
	}
	
	/**
	* Unloads the currently opened application
	* @return	Void
	*/
	public static function close():Void {
		var wndMGR:Windows = Windows.getInstance()
		wndMGR.closeAllFromPlaceholder("__APPLICATION")
	}
	
	/**
	* Retrieves the current loaded application's name
	* @return	String
	*/
	public static function getApplicationName():String {
		var oApp:Object = FWAConfiguration.main.applications.app[FWAConfiguration.applicationID]
		return(oApp.name._value)
	}
	
	/**
	* Sets the object to use as preloader listener for the application load process
	* @param	lst (Object) Listener object
	* @return	Void
	*/
	public static function setListener(lst:Object):Void {
		listener = lst
	}
}