import com.fwa.data.XMLConstruct;
import com.fwa.system.Configuration;
import com.fwa.ui.Placeholders;
import com.fwa.ui.Window;
import com.fwa.ui.Windows;
import com.fwa.debug.Tracer;
import mx.utils.Delegate;

/**
* Starter Class
* This class initialises the main container for both, the Frame and Applications
* @version	1.0
* @since	27 Nov 2006
*/
class com.fwaapi.Starter extends MovieClip {
	//properties
	var config:Object;
	var app:MovieClip;
	var marco:MovieClip;
	var wndMGR:Windows;
	
	/**
	* Constructor
	*/
	public function Starter(){
		wndMGR = Windows.getInstance()
		loadMainConfiguration()
	}
	
	/**
	* Loads the MainConfig.xml file and stores its data into the FWA System Configuration
	* @return	Void
	*/
	private function loadMainConfiguration():Void {
		var ref = this
		config = new XMLConstruct();
		config.onLoad = function(){
			Configuration.store("mainconfig", this)
			ref.initialiseLayout()
		}
		config.load("mainconfig.xml")
	}
	
	/**
	* Initialises all the Layout elements, and starts loading the WireFrame
	* @return	Void
	*/
	private function initialiseLayout():Void {
		Placeholders.removeIfExists(true)
		Placeholders.createPlaceholder("__APPLICATION", this, this.getNextHighestDepth())
		Placeholders.createPlaceholder("__MARCO", this, this.getNextHighestDepth())
		Placeholders.createPlaceholder("__ALERTS", this, this.getNextHighestDepth())
		
		var marco_file:String = config.marco.template._value
		var wnd_marco:Window = wndMGR.open("__MARCO", {filename:marco_file, modal:false, identifier:"marco"})
	}
}