import com.fwa.system.FWAConfiguration;
import com.fwa.controllers.ScrollPane;
import com.fwaapi.SystemProxy;
import com.fwamarco.consoles.AbstractConsole;
import com.fwamarco.consoles.ConsolesManager;
import mx.utils.Delegate;

/**
* This class manages the Applications List Console functionality.
* Integration with the ConsolesManager is managed by AbstractConsole.
* 
* @see		com.fwamarco.consoles.AbstractConsole
* @see 		com.fwamarco.consoles.ConsolesManager
* 
* @version	1.0
* @since 	11 Mar 2007
*/
class com.fwamarco.consoles.Applications extends AbstractConsole {
	//layout elements
	private var bt_close:Button;
	private var clip_bg:MovieClip;
	private var apps_list:MovieClip;
	private var listCreated:Boolean;
	private var oApps:Object;
	
	
	/**
	* Constructor
	* Initialises the Application Console layout elements and the Applications list 
	* configuiration data
	*/
	public function Applications(){
		bt_close.onRelease = Delegate.create(ConsolesManager, ConsolesManager.closeAll);
		oApps = FWAConfiguration.main.applications;
		listCreated = false;
	}
	
	
	/**
	* Displays the console, and populates the applications list
	*/
	public function show():Void {
		super.show();
		listApplications();
	}
	
	
	/**
	* Creates the Applications list in the ScrollPane
	*/
	private function listApplications():Void {
		if(!listCreated){
			var scrollPane:ScrollPane = ScrollPane(apps_list);
			scrollPane.removeAll();
			var apps:Number = oApps.app.length;
			if(apps>1){
				for(var i:Number = 0; i<apps; i++){
					var tApp:Object = oApps.app[i];
					var item_name:String = "app"+i;
					var item:MovieClip = scrollPane.addItem("app_item", item_name, 0, scrollPane.getHeight());
					//trace("item created:"+item._name);
					item.label = tApp.name._value
					item.t_appname.text = tApp.name._value;
					item.datos = {id:i}
					item.onSelect = Delegate.create(this, openNewApplication);
				}
			}
			listCreated = true;
		}
	}
	
	
	/**
	* Opens the selected application in the ScrollPane.
	* @param	itemObject (Object) Selected item's stored data object
	*/
	private function openNewApplication(itemObject:Object):Void {
		SystemProxy.initApplication(itemObject.id);
		hide();
	}
}