
class com.parker.menu.dropdown.Menu extends MovieClip {
	
	private var menu_items:Array
	private var parent_menu:MovieClip
	private var parent_item:MovieClip
	private var open:Boolean
	private var int_id:Number
	
	public function Menu(){
		menu_items = new Array()
		hide()
	}
	
	public function init():Void {
	}
	
	public function setParent(menu:MovieClip, item:MovieClip):Void {
		parent_menu = menu
		parent_item = item
		
		debug(" ")
		debug("MENU setParent:")
		debug("  menu:"+ parent_menu)
		debug("  item:"+ parent_item)
		debug(" ")
	}
	
	public function getParent():Object {
		return( {menu:parent_menu, item:parent_item} )
	}
	
	public function addItem(linkage:String, initObj:Object):MovieClip {
		debug(" ")
		debug("MENU: addItem")
		debug("  > "+initObj.label._value)
		
		var item_name:String = "item_" + menu_items.length
		var item:MovieClip = this.attachMovie(linkage, item_name, this.getNextHighestDepth())
		item.initObject = initObj
		
		menu_items.push(item)
		
		return (item)
	}
	
	public function isOpen():Boolean {
		trace("MENU isOpen:"+open)
		return (open)
	}
	
	public function getItems():Array {
		return menu_items
	}
	
	//MOUSE CHECK METHODS/////////////////////////////////////////////////////////////////////
	public function isMouseInside():Boolean {
		debug("MENU isMouseInside?")
		//check if mouse is within this menu
		if((this._parent._xmouse>this._x && this._parent._xmouse< this._x+this._width) && 
			(this._parent._ymouse>this._y && this._parent._ymouse< this._y+this._height)){
			trace("  mouse within this menu")	
			return(true)
		}else{
			//check if mouse is within Parent Menu Item
			if((parent_item._xmouse>parent_item._x && parent_item._xmouse< parent_item._x+parent_item._width) && 
			(parent_item._ymouse>parent_item._y && parent_item._ymouse< parent_item._y+parent_item._height)){
				trace("  mouse within parent item")	
				return(true)
			}else{
				//if got here, mouse is outside
				trace("mouse outside this menu or parent item")
				return(false)
			}
		}
	}
	
	private function checkMouseInside():Void{
		if(isMouseInside()==false){
			hide()
			clearInterval(int_id)
		}
	}
	
	
	//VISIBILITY METHODS////////////////////////////////////////////////////////
	public function show(){
		open = true
		this._visible = true
		if(getParent().menu!==undefined){
			//if this menu has a parent, means that is a submenu
			//in that case, display parent and check for mouse position
			//parent_menu.show()
			getParent().menu.show()
			clearInterval(int_id)
			int_id = setInterval(this, "checkMouseInside", 500)
		}
		//this._x = Math.round(parent_item._x)
		//this._y = Math.floor(parent_item._y+parent_item._height-1)
		/*
		if(_root.siteMGR.transitionsEnabled()==true){
			this.alphaTo(100, _root.siteMGR.getTransitionsSpeed(), "easeOutSin")
		}else{
			this._alpha = 100
		}
		*/
	}
	
	public function hide():Void {
		open = false
		onFadeDone()
		/*
		if(_root.siteMGR.transitionsEnabled()==true){
			this.alphaTo(0,0.3,"easeOutSin",0,this.onFadeDone)
		}else{
			this._alpha = 0
			this.onFadeDone()
		}
		*/
	}
	
	private function onFadeDone():Void {
		this._visible = false
	}
	
	//AUX METHODS///////////////////////////////////////////////////////////////////
	private function debug(msg:String):Void {
		//trace(msg)
	}
}