﻿// #############################################################################
// Validate Class
// #############################################################################
// Description:
//
//
// Author: Javier Alejandro Corra
// Agency: Wunderman
// Version: 1.0
// Last Update: 07/06/2006
// #############################################################################
// 
// ABSTRACT
class com.wunderman.utils.Validate {

  // ###########################################################################
  // # CONSTRUCTOR
  // ###########################################################################
  private function Validate() {
  }


  // ###########################################################################
  // # STATIC METHODS
  // ###########################################################################

  // Indica si el texto tiene letras
  public static function isChar(str:String):Boolean {
    var result = true;
    var i:Number = 0;
    var letter:String;

    while(i< str.length) {
      letter = str.substr(i, 1).toLowerCase();
      // Si no esta entre a-z  o es espacio
      if(!(letter>="a" && letter<="z") && (letter != " ")) {
        result = false;
      };
      i++;
    };

    return result && !Validate.isEmpty(str);
  }


  // Indica si el texto tiene numeros
  public static function isNumber(str:String):Boolean {
    var result:Boolean = true;
    var i:Number = 0;
    var letter:String;

    while(i<str.length) {
      letter = str.substr(i, 1).toLowerCase();
      if(!(letter>="0" && letter<="9")) {
        result = false;
      };
      i++;
    };

    return result && !Validate.isEmpty(str);
  }

  // Indica si un texto tiene formato de e-mail
  public static function isEmail(str:String):Boolean {
    var result:Boolean = true;

    if(str == "") result = false;
    if(str.indexOf("@")==-1) result = false;
    if(str.indexOf(".")==-1) result = false;
    if(str.indexOf("@")!==str.lastIndexOf("@")) result = false;

    return result;
  }

  // Indica si un texto esta vacio
  public static function isEmpty(str:String):Boolean {
   // return (Trim(str) == "");
   return (str == undefined) || (str.length < 1);
  }

  // Chequea el largo del contenido de un field. Le paso la longuitud minima
  // y un opcional de maxima
  public static function checkLength(val:String, min:Number, max:Number):Boolean {
    var len:Number = val.length;
    var rsp:Boolean = true;

    if(len < min) {
      rsp = false;
    } else if( (max != undefined) && (len > max) ) {
      rsp = false;
    };

    return rsp;
  }

  // Si el parametro es undefined, devuelve un string vacio
  public static function safeParam(param:String):String {
	param = (trim(param) == "") ? "" : param
    param = (param == "undefined") ? "" : param;
    return (param == undefined) ? "" : param;
  }


  public static function formatDate(d, m, a, format:String):String {
    var i:Number;
    var date:String = "";
    var fmt:Array = format.split("-");

    for(i=0; i<3; i++) {
      switch(fmt[i]) {
        case "dd":
          date += padNumber(d, 2);
          break;

        case "mm":
          date += padNumber(m, 2);
          break;

        case "aaaa":
          date += padNumber(a, 4);
          break;
      };//end-switch
    };//end-for

    return date;
  }


  // Agrega ceros a la izquierda de un numero. Hasta tener "digits" digitos.
  public static function padNumber(num:Number, digits:Number):String {
    var nstr:String = String(num);

    while(nstr.length < digits) {
      nstr = "0" + nstr;
    };

    return nstr;
  }

	public static function trimLeft(str:String):String {
		// leading whitespace chars
		var l:Number
		for (l=0; l < str.length; l++){
			   if ((str.charAt(l) != " ") && (str.charAt(l) != "\n") && (str.charAt(l) != "\r") && (str.charAt(l) != "\t"))
			   {
				 break;
			   }
		}
		return str.slice(l);
	}
	public static function trimRight(str:String):String {
		// trailing whitespace chars
		var t:Number
		for (t = str.length; t > 0; t--) {
			if ((str.charAt(t) != " ") && (str.charAt(t) != "\n") && (str.charAt(t) != "\r") && (str.charAt(t) != "\t"))
			{
				break;
			}
		}
		return str.slice(0, t);
	}
	
	public static function trim(str:String):String {
		return trimLeft(trimRight(str))
	}

}
/*
  public static function padding(str, len, pad, side):String {
    var slen:Number = len - str.length;

    if(slen<=0) return str;

    if(!pad.length) pad = " ";

    var padlen:Number = pad.length;

    var p = "";

    while(padlen<=slen) {
      slen -= padlen;
      p += str;
    };

    p += str.substring(0, slen);
    var mid = Math.floor(p.length/2);

    if(side == "PAD_LEFT") return p + str;
    else if(side == "PAD_BOTH") return p.substr(0, mid) + str + p.substr(mid);
    else return str + p; //"PAD_RIGHT
  }
*/

/*
// ktmp = new String( "  \tfoo  \n" );
trace( "'" + tmp + "'" );
trace( "'" + tmp.trimRight() + "'" );
trace( "'" + tmp.trimLeft() + "'" );
trace( "'" + tmp.trim() + "'" );
*/

/*
* static BOOL 	IsAlpha (TCHAR c)
 	Tests if the character is a-z, A-Z (or local equivalent).
static BOOL 	IsAlphaNumeric (TCHAR c)
 	Tests if the character is a-z, A-Z, 0-9, or local equivalent.
static BOOL 	IsNumeric (TCHAR c)
 	Tests if the character is 0-9, or local equivalent.
static BOOL 	IsLower (TCHAR c)
 	Tests if the character is a-z (or local equivalent).
static BOOL 	IsUpper (TCHAR c)
 	Tests if the character is A-Z, or local equivalent.
static BOOL 	IsSpace (TCHAR c)
*/