/*
Copyright 2005 Midnight Coders, LLC

Licensed under the Midnight Coders license (the "License");
You may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.themidnightcoders.com/licensing/asdklicense.htm

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

import asdk.*;

class asdk.StringUtils
{
	static function objectToString( object ) : String
	{
		var objectString : String = "";
		var hasFields : Boolean = false;
		for( var field : String in object )
		{
			hasFields = true;
			objectString += field;
			objectString += objectToString( object[ field ] );
		}
		
		if( !( hasFields ) )
			objectString += object;
		
		return objectString;
	}
	
	static function convertToHex( string : String ) : String
	{
		var stringLength : Number = string.length;
		var asciiCodes : Number = 0;
		for( var i : Number = 0; i < stringLength; i ++ )
			asciiCodes += string.charCodeAt( i );
		
		return asciiCodes.toString( 16 );
		
	}
	
	static function getHashCode( object ) : String
	{
		return convertToHex( objectToString( object ) );
	}
	
	static function replace( string : String, before : String, after : String ) : String
	{
	    if( string.indexOf( before.charAt( 0 ) ) == -1 )
	      return string;
	
	    var buffer = "";
	    var index = 0;
	
	    while( true )
	      {
	      var match = string.indexOf( before, index );
	
	      if( match == -1 )
	        {
	        buffer = buffer + string.substring( index, string.length );
	        return buffer;
	        }
	      else
	        {
	        buffer = buffer + string.substring( index, match );
	        buffer = buffer + after;
	        index = match + before.length;
	        }
              }
	}
}