/*
Copyright 2005 Midnight Coders, LLC

Licensed under the Midnight Coders license (the "License");
You may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.themidnightcoders.com/licensing/asdklicense.htm

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

import asdk.*;
import asdk.iterator.*;
import asdk.condition.*;

class asdk.condition.UnaryAnd implements UnaryCondition
{
	private var conditions : Array;
	
    // expression1 may be an array of other unary expressions
    // expression2 is optional and must be an intance of UnaryCondition
    function UnaryAnd( condition1, condition2 : UnaryCondition )
	{
		if( condition1 instanceof UnaryCondition )
		{
            this.conditions = new Array();
            this.conditions.push( condition1 );
            this.conditions.push( condition2 );
		}
		else
		{
            this.conditions = condition1;
		}
	}
	
	function execute( operand ) : Boolean
	{
        var arrayIterator : Iterator = new ArrayIterator( conditions );
		
		while( arrayIterator.hasNext() )
			if( !arrayIterator.getNext().execute( operand ) )
			  return false;
		
		return true;
	}
}