/*
Copyright 2005 Midnight Coders, LLC

Licensed under the Midnight Coders license (the "License");
You may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.themidnightcoders.com/licensing/asdklicense.htm

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

import asdk.*;

class asdk.iterator.HashMapIterator implements Iterator
{
	private var hashes : Vector;
	private var hashmap;
	private var table : Object;
	private var index : Number;
	private var iterateKeys : Boolean;
	private var curLinkedListItem : LinkedListItem;
	
	function HashMapIterator( hashes : Vector, table : Object, hashmap, iterateKeys : Boolean )
	{
		this.hashes = hashes;
		this.hashmap = hashmap;
		this.table = table;
		this.index = 0;
		this.iterateKeys = iterateKeys;
	}
	
	function hasNext() : Boolean
	{
		return hasNextItem();
	}
	
	function getNext()
	{
		curLinkedListItem = getNextItem();  
        
		if( iterateKeys )
			return curLinkedListItem.getData().key;
		else
			return curLinkedListItem.getData().value;		
	}
	
	function remove() : Void
	{
		hashmap.remove( curLinkedListItem.getData().key );                
        index--;
	}
	
	private function getNextItem() : LinkedListItem
	{
		if( curLinkedListItem == null || curLinkedListItem.getNext() == null )
		{
			curLinkedListItem = table[ hashes.getItemAt( index ) ].getFirst();
			index++;
		}
		else
		{
			curLinkedListItem = curLinkedListItem.getNext();
		}
		
		return curLinkedListItem;
	}
	
	private function hasNextItem() : Boolean
	{
		if( curLinkedListItem == null )
		{
			return hashes.getSize() > 0;
		}
		else
		{
			if( curLinkedListItem.getNext() != null )
			  return true;
			else
			  return index < hashes.getSize();
		}
	}
}