/*
Copyright 2005 Midnight Coders, LLC

Licensed under the Midnight Coders license (the "License");
You may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.themidnightcoders.com/licensing/asdklicense.htm

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

import asdk.xml.*;
import asdk.*;

class asdk.xml.Nodes implements Iterator
{

    var list : NodeList;
    var currentNodeObj : Node;

    public function Nodes( nodeListOrNode )
    {
        if( nodeListOrNode == undefined )
        {
            list = new NodeList();
        }
        else if( nodeListOrNode instanceof Node )
        {
            var list : NodeList = new NodeList();
            list.append( nodeListOrNode );
            this.list = list;
        }
        else
        {
            this.list = nodeListOrNode;                    
        }
        
        reset();
    }

    public function hasNext() : Boolean
    {
        return (currentNodeObj != null);   
    }
    
    public function getNext()
    {
        return nextNode();
    }
    
   /**
    * Remove all the nodes from the current Node to the last Node.
    */
    public function remove() : Void
    {
        while( hasNext() )
          nextNode().remove();
    }

   /**
    * Move to the first Node.
    */
    public function reset()
    {    
        currentNodeObj = list.firstNode;
    }

   /**
    * Return the current Node, or null if there is none.
    */
    public function currentNode() : Node
    {
        return (currentNodeObj == undefined ? undefined : currentNodeObj.getNode());
    }

   /**
    * Move to the first Node and return it, or null if there is none.
    */
    public function firstNode() : Node 
    {
        reset();
        return currentNode();
    }

   /**
    * Return the current Node and then advance to the next one if present.
    */
    public function nextNode() : Node
    {
        if( currentNodeObj == null )
          return null;

        var node = currentNodeObj.getNode();
        currentNodeObj = currentNodeObj.nextNode;
        return node;
    }

   /**
    * Return the number of Nodes in the list.
    */
    public function size()
    {
        return list.size();
    }

   /**
    * Return my underlying NodeList.
    */
    public function getNodeList() : NodeList
    {
        return list;
    }
}