import com.fwa.events.ListenerBroadcaster;
import mx.utils.Delegate;

/**
* This class contains the functionality of a Scroll component.
* 
* @version	1.0
* @date 	9 Dec 2006
*/
class com.fwa.controllers.ScrollBar extends MovieClip {
	
	//elements
	private var bar:MovieClip;
	private var slider:MovieClip;
	private var bt_up:MovieClip;
	private var bt_down:MovieClip;
	
	//properties
	private var broadcaster:ListenerBroadcaster;
	private var step:Number;
	private var y_offset:Number;
	public var addListener:Function;
	public var removeListener:Function;
	
	
	/**
	* Constructor
	*/
	public function ScrollBar(){
		//delegate events
		slider.onPress = Delegate.create(this, sliderPress);
		slider.onRelease = slider.onReleaseOutside = Delegate.create(this, sliderRelease);
		bt_up.onRelease = Delegate.create(this, scrollUp);
		bt_down.onRelease = Delegate.create(this, scrollDown);
		
		//init properties
		step = 5
		broadcaster = new ListenerBroadcaster();
		addListener = Delegate.create(broadcaster, broadcaster.addListener);
		removeListener = Delegate.create(broadcaster, broadcaster.removeListener);
	}
	
	/**
	* Initialises the ScrollBar
	* @return	Void
	*/
	public function init():Void {
		y_offset = bar._y
		reset()
	}
	
	public function reset():Void{
		slider._y = y_offset
	}
	
	public function scrollDown():Void {
		slider._y += step
		if(slider._y>slider.maxY){
			slider._y = slider.maxY
		}
		onUpdated()
	}
	
	public function scrollUp():Void {
		slider._y -= step
		if(slider._y<slider.minY){
			slider._y = slider.minY
		}
		onUpdated()
	}
	
	public function setSliderSize(percent):Void {
		this.slider._yscale = Math.floor(percent)
		slider.minX = slider._x
		slider.maxX = slider._x
		slider.minY = y_offset //slider._y
		slider.maxY = (bar._height - slider._height)+slider.minY //+2
	}

	private function sliderPress():Void {
		slider.startDrag(false, slider.minX, slider.minY, slider.maxX, slider.maxY)
	}
	
	private function sliderRelease():Void {
		stopDrag()
		onUpdated()
	}
	
	private function onUpdated():Void {
		var sliderPercPos:Number = ((slider._y-y_offset)*100/(slider.maxY-y_offset))
		broadcaster.broadcastMessage("onUpdate", [sliderPercPos])
	}
}