/**
* @class 	NodeRetriever (Static)
* This class is used to retrieve a node from a list of nodes using its identifiers.
* 
* @author	Federico Campo Piombi [federicocp@hotmail.com]
* @version	1.0
* @date 	15 Nov 2006
*/
class com.fwa.data.NodeRetriever {
	
	/**
	* @constructor
	*/
	private function NodeRetriever() {}
	
	/**
	* @method 	retrieveFirstNode
	* This method retrieves the first node found when searching for an identifier within a list of nodes.
	* 
	* @param	node_identifier (String) Identifier of the node to retrieve
	* @param	nodes (Object) An array of nodes to serch within
	* @return	Object
	*/
	public static function retrieveFirstNode(node_identifier, nodes:Array):Object {
		var node:Object = retrieveNodes(node_identifier, nodes)[0]
		return(node)
	}
	
	/**
	* @method 	retrieveNodes
	* This method retrieves an Array containing all the nodes found when searching 
	* for an identifier within a list of nodes.
	* 
	* @param	node_identifier (String) Identifier of the node to retrieve
	* @param	nodes (Object) An array of nodes to serch within
	* @return	Array
	*/
	public static function retrieveNodes(node_identifier:String, nodes:Object):Array {
		var nodescount:Number = nodes.length
		var found:Array = new Array()
		
		for(var i:Number = 0; i<nodescount; i++){
			if(nodes[i].identifier._value == node_identifier){
				found.push(nodes[i])
			}
		}
		
		return(found)
	}
	
}