import com.fwa.system.processes.ISystemProcess;
import com.fwa.system.gateway.ExternalData;
import com.fwa.system.Configuration;
import com.fwa.system.FWAConfiguration;
import com.fwa.data.NodeRetriever;
import com.fwa.debug.Tracer;
import mx.utils.Delegate;

/**
* LoadSubtitles (System Process)
* This class loads the Subtitles XML file and stores it into the Configuration under the "subtitles" identifier
* @author	Federico Campo Piombi [federicocp@hotmail.com]
* @version	1.0
* @date 	10 Nov 2006
*/
class com.fwa.system.processes.LoadSubtitles implements ISystemProcess {
	
	//PROPERTIES
	private var inited:Boolean
	
	
	/**
	* @constructor
	*/
	public function LoadSubtitles(){
		inited = false
	}
	
	/**
	* Initialises the process: Starts loading the main subtitles files usign ExternalData
	*/
	public function init():Void {
		if(inited == false){
			inited = true
			onProcessStarted(1)
			
			var sub:ExternalData = new ExternalData()
			var app_path:String = FWAConfiguration.application
			var lang:String = FWAConfiguration.language
			
			sub.filename = app_path+lang+"/text_elements/subs.xml"
			sub.onLoad = Delegate.create(this, this.elementLoaded)
			sub.onLoadError = Delegate.create(this, this.onProcessAborted)
			sub.load()
		}
	}
	
	/**
	* @return	String
	*/
	public function toString():String {
		return("LoadSubtitles")
	}
	
	/**
	* This method is executed every time an external configuration file is loaded
	* @param	data (Object) The data object loaded
	* @param	filename (String) The name of the loaded file
	*/
	private function elementLoaded(data:Object, filename:String):Void {
		//add this element to the Configuration
		Configuration.store("subtitles", data)
		onProcessUpdated(1,1)
		onProcessCompleted()
	}
	
	
	//EVENTS
	public function onProcessStarted(total_subprocesses:Number):Void {}
	public function onProcessUpdated(current_subprocess:Number, total_subprocesses:Number):Void {}
	public function onProcessCompleted():Void {}
	public function onProcessAborted(reason:String):Void {}
}