import com.fwa.system.FWAConfiguration;
import com.fwaapi.Tooltip;
import mx.utils.Delegate;

/**
* This class 
*/
class com.fwamarco.ui.BotonGeneral extends MovieClip {
	//layout elements
	private var icon:MovieClip;
	private var bt_general_off:MovieClip;
	private var bt_general_over:MovieClip;
	private var clip_bgcolor:MovieClip;
	
	//properties
	private var t_tooltip:String = "";
	
	//hide this public methods
	private var onRollOver:Function;
	private var onRollOut:Function;
	private var onReleaseOutside:Function;
	
	public function BotonGeneral(){
		//define events
		this.onRollOver = Delegate.create(this, doOver)
		this.onRollOut = Delegate.create(this, doOut)
		this.onReleaseOutside = Delegate.create(this, doOut)
		
		//apply color
		var color_config:String = FWAConfiguration.main.marco.colors.controls_buttons._value
		var clr:String = "0x"+color_config
		var bt_color:Color = new Color(clip_bgcolor);
		bt_color.setRGB(Number(clr))
		
		//set the default state
		doOut()
	}
	
	public function setIcon(id):Void {
		icon.gotoAndStop(id)
	}
	
	public function setTooltip(msg:String):Void {
		if(msg!== undefined){
			t_tooltip = msg
		}
	}
	public function clearTooltip():Void {
		t_tooltip = ""
	}

	private function doOver():Void {
		bt_general_off._visible = false
		bt_general_over._visible = true
		if(t_tooltip!==""){
			Tooltip.show(t_tooltip)
		}
	}
	
	private function doOut():Void {
		bt_general_off._visible = true
		bt_general_over._visible = false
		if(t_tooltip!==""){
			Tooltip.hide()
		}
	}
}