/*
Copyright 2005 Midnight Coders, LLC

Licensed under the Midnight Coders license (the "License");
You may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.themidnightcoders.com/licensing/asdklicense.htm

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

import asdk.*;

class asdk.KeySet extends AbstractCollection implements Set
{
	private var parent;
	
	function KeySet( parent )
	{
		this.parent = parent;
	}

	function getSize() : Number
	{
		return parent.getSize();
	}

	function containsItem( item ) : Boolean
	{
		return parent.containsKey( item );
	}

	function removeItem( item ) : Boolean
	{
		return parent.remove( item ) != null;
	}

	function clear() : Void
	{
		parent.clear();
	}
	
	function iterator() : Iterator
	{
		return parent.iterator( ASDKConstants.KEYS );
	}
}
