/*
Copyright 2005 Midnight Coders, LLC

Licensed under the Midnight Coders license (the "License");
You may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.themidnightcoders.com/licensing/asdklicense.htm

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

import asdk.*;
import asdk.algorithm.*;
import asdk.functions.*;

class asdk.algorithm.Applying
{
	static function forEach( collection : Collection, functionObj : UnaryFunction )
	{
		var iterator : Iterator = collection.iterator();
		
		while( iterator.hasNext() )
			functionObj.execute( iterator.getNext() );
	}
	
	static function forEachAndNext( collection : Collection, startingPoint, functionObj : BinaryFunction ) 
	{
		var iterator : Iterator = collection.iterator();
		var result = startingPoint;
		
		while( iterator.hasNext() )
		  result = functionObj.execute( result, iterator.getNext() );
		
		return result;		
	}
	
	static function inject( collection : Collection, initialValue, functionObj : BinaryFunction )
	{
		var iterator : Iterator = collection.iterator();
		var resultObj = initialValue;
		
		while( iterator.hasNext() )
		{
			var nextObj = iterator.getNext();
			resultObj = functionObj.execute( resultObj, nextObj );
		}
		
		return resultObj;
	}
}