/*
Copyright 2005 Midnight Coders, LLC

Licensed under the Midnight Coders license (the "License");
You may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.themidnightcoders.com/licensing/asdklicense.htm

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

import asdk.*;
import asdk.functions.*;
import asdk.condition.*;

class asdk.functions.Concatenation implements BinaryFunction
{
    var stringPart;
    
    function Concatenation( stringPart )
    {
        this.stringPart = stringPart;
    }
    
	function execute( operand1, operand2 )
    {
        if( stringPart instanceof UnaryFunction )
            operand2 = stringPart.execute( operand2 );
            
        if( Inspector.findObjectType( operand2 ) != "string" )
            operand2 = operand2.toString();

        return operand1.toString() + operand2;
    }
}