/*
Copyright 2005 Midnight Coders, LLC

Licensed under the Midnight Coders license (the "License");
You may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.themidnightcoders.com/licensing/asdklicense.htm

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

import asdk.*;
import asdk.iterator.*;

class asdk.iterator.ObjectPropertiesIterator implements Iterator
{
	private var object;
	private var props : Array;
	private var propsIterator : Iterator;
	private var lastKey;
	
	function ObjectPropertiesIterator( object )
	{
		this.object = object;
		this.props = new Array();
		
		for( var name in object )
		  this.props.push( name );
		  
		this.propsIterator = new ArrayIterator( this.props );
	}
	
	function hasNext() : Boolean
	{
		return this.propsIterator.hasNext();
	}
	
	function getNext()
	{
		lastKey = this.propsIterator.getNext();		
		return lastKey;
	}
	
	function remove() : Void
	{
		object[ lastKey ] = undefined;
	}	
}