/*
Copyright 2005 Midnight Coders, LLC

Licensed under the Midnight Coders license (the "License");
You may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.themidnightcoders.com/licensing/asdklicense.htm

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

import asdk.xml.*;

class asdk.xml.Attribute extends Node
{
    public var name:String;
    public var value:String;
    public var namespace:String;
    private var prefix:String;
    private var isNamespace:Boolean; // true if this attribute is a namespace declaration
    private var isId:Boolean; // true if this attibute is an id

    public function Attribute( name:String, value:String )
    {
        this.name = name;

        var colonIndex = this.name.indexOf( ":" );

        if( colonIndex > -1 )
        {
            this.prefix = this.name.substr( 0, colonIndex );
            this.name = this.name.substr( colonIndex + 1 );
        }

        this.value = value;
        initialize();
    }

    public function initialize()
    {
        if( FlexmlConstants.XMLNS == this.name || FlexmlConstants.XMLNS == this.prefix )
        {
          this.isNamespace = true;
          this.namespace = FlexmlConstants.XMLNS_NAMESPACE;
        }
        else if( FlexmlConstants.ID == this.name || FlexmlConstants.ID_CASE == this.name )
        {
          this.isId = true;
        }
    }

    public function getName()
    {
        return name;
    }

    public function getValue()
    {
        return value;
    }
}
