import com.fwa.ui.IPreloader

/**
* This class manages the View of the Buffer Bar control.
* When a Sound is preloaded in the FWA this bar displays its progress
* 
* @version 	1.0
* @date 	17 Dec 2006
*/
class com.fwamarco.loaders.BufferBar extends MovieClip implements IPreloader {
	
	//properties
	private var barra:MovieClip
	
	
	/**
	* Constructor
	*/
	public function BufferBar(){
		hide()
	}
	
	
	/**
	* Receives the current load's progress and updates the bar percent
	* @param	pct (Number) current load progress percent
	* @return	Void
	*/
	public function setProgress(pct:Number):Void {
		barra._xscale = (pct>100)? 100 : pct
	}
	
	/**
	* Hides the preloader
	* @return 	Void
	*/
	public function hide():Void {
		//this._alpha = 50
		this._visible = false
	}
	
	/**
	* Displays the preloader
	* @return 	Void
	*/
	public function show():Void {
		//this._alpha = 100
		this._visible = true
	}
}