/**
* @class	Tracer
* @tooltip	This class provides methods to trace messages in the output window (or anywhere else)
* 			It formats the output message so you can specify which class, method or even package outputs the given message
* @author	Federico Campo Piombi
* @version	1.0
* @date		01 Nov 2006
*/
class com.wunderman.debug.Tracer {
	
	/**
	* @constructor
	*/
	private function Tracer(){}
	
	/**
	* @method	output
	* @tooltip	Displays a formatted message (and other useful information) in the output panel
	* @param	msg (String) Message to output
	* @param	method (String) Method that ouputs the message
	* @param	classs (String) Class that outputs the message
	* @param	pack (String) Package that outputs the message
	*/
	public static function output(msg:String, method:String, classs:String, pack:String):Void {
		var o_str:String = ""
		o_str += (pack!==undefined)? "("+pack+") " : ""
		o_str += (classs!==undefined)? "["+classs+"] " : ""
		o_str += (method!==undefined)? "<"+method+"> " : ""
		o_str += msg
		
		trace(o_str)
	}
}