/*
Copyright 2005 Midnight Coders, LLC

Licensed under the Midnight Coders license (the "License");
You may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.themidnightcoders.com/licensing/asdklicense.htm

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

import asdk.*
import asdk.iterator.*;

class asdk.IteratorFactory
{
	static function createIterator( object ) : Iterator
	{
		if( typeof( object.iterator ) == "function" )
		  return object.iterator();
		else if( object.length != undefined && 
				 typeof( object.pop ) == "function" &&
				 typeof( object.push ) == "function" )
		  return new ArrayIterator( object );
		else if( typeof( object ) == "object" )
		  return new ObjectPropertiesIterator( object );
		else 
		  return undefined;
	}
}