/*
Copyright 2005 Midnight Coders, LLC

Licensed under the Midnight Coders license (the "License");
You may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.themidnightcoders.com/licensing/asdklicense.htm

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

import asdk.*;

class asdk.algorithm.Copying
{
	static function copy( source : Collection, destination : Collection, start : Number, end : Number )
	{
		var iterator : Iterator = source.iterator();
		
		if( start == undefined )
		  start = 0;
		  
		if( end == undefined )
		  end = source.getSize();
		  
		for( var i = 0; iterator.hasNext(); i++ )
			if( i >= start && i <= end )
			   destination.addItem( iterator.getNext() );
	}
	
	static function copyBackward( source : Collection, destination : Collection, start : Number, end : Number )
	{
		var iterator : Iterator = source.iterator();
		
		if( start == undefined )
		  start = source.getSize();
		  
		if( end == undefined )
		  end = 0;
		
		var stack : Stack = new Stack();
		  
		for( var i = 0; iterator.hasNext(); i++ )
			if( i >= end && i <= start )
			   stack.push( iterator.getNext() );
		
		destination.addAll( stack );
	}
	
}