/*
Copyright 2005 Midnight Coders, LLC

Licensed under the Midnight Coders license (the "License");
You may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.themidnightcoders.com/licensing/asdklicense.htm

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

import asdk.xml.*;

class asdk.xml.Elements extends Nodes
{
     /**
      * Construct an Elements associated with either the specified node list 
      * or the single specific element
      * @param list The list of Element nodes.
      */
     public function Elements( nodeListOrElement )
     {
        super( nodeListOrElement );
     }
   
     /**
      * Return the current Element, or null if there is none.
      */
     public function current() : Element
     {
		return Element( currentNode() );
     }

     /**
      * Move to the first Element and return it, or null if there is none.
      */
     public function first() : Element
     {
        var e = firstNode();
        return e;
     }
   
     /**
      * Return the current Element and then advance to the next one if present.
      */
     public function next() : Element
     {
        var e = nextNode();
        return e;
     }
}