/*
Copyright 2005 Midnight Coders, LLC

Licensed under the Midnight Coders license (the "License");
You may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.themidnightcoders.com/licensing/asdklicense.htm

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

import asdk.xml.*;

class asdk.xml.ElementsFilter extends Elements
{
    public function ElementsFilter( nodes:NodeList )
	{
		super( nodes );
	}
    
   /**
   * Move to the first Element.
   */
  public function reset()
  {
      super.reset();

      while( currentNodeObj != null && !(currentNodeObj.getNode() instanceof Element) )
        currentNodeObj = currentNodeObj.nextNode;
  }

  /**
   * Move to the first Element and return it, or null if there is none.
   */
  public function nextNode() : Node
  {
      if( currentNodeObj == null )
        return null;

      var node = currentNodeObj.getNode();

      do
        {
        currentNodeObj = currentNodeObj.nextNode;
        }
      while( currentNodeObj != null && !(currentNodeObj.getNode() instanceof Element) );

      return node;
  }

  /**
   * Return the number of Elements in the list.
   */
  public function size()
  {
  trace( "in size " );
      var count = 0;

      for( var node = list.firstNode; node != null; node = node.nextNode )
      {
        if( node.getNode() instanceof Element )
          ++count;
      }

      return count;
  }    
}