import mx.utils.Delegate
import com.fwa.events.ListenerBroadcaster
class com.fwa.controllers.media.ProgressBar extends MovieClip {
	
	private var Broadcaster:ListenerBroadcaster
	private var playback:MovieClip
	private var buffer:MovieClip
	private var _seekenabled:Boolean
	
//CONSTRUCTOR
	public function ProgressBar(){
		Broadcaster = new ListenerBroadcaster()
		_seekenabled = true
		playback._xscale = 0
		buffer._xscale = 0
		playback.onPress = Delegate.create(this, playbackPress)
		playback.onRelease = playback.onReleaseOutside = Delegate.create(this, playbackRelease)
	}
	
	
//PUBLIC METHODS
	public function getSize():Number {
		return(playback._width)
	}
	
	public function getProgress():Number {
		return(playback._xscale)
	}
	
	public function setPlaybackProgress(percent:Number):Void {
		playback._xscale = percent
	}
	
	public function setBufferProgress(percent:Number):Void {
		buffer._xscale = percent
	}
	
	public function addListener(obj:Object):Boolean {
		trace("PB: addListener")
		return( Broadcaster.addListener(obj) )
	}
	
	public function removeListener(obj:Object):Boolean {
		return( Broadcaster.removeListener(obj) )
	}

	
//PRIVATE METHODS
	// start playhead scrubbing
	private function playbackPress():Void {
		if(_seekenabled){
			var ref:ProgressBar = this
			playback.onEnterFrame = function(){
				var scl:Number = (this._xmouse/this._width)*(this._xscale/100)*(this._xscale/100);
				if(scl < 0.02) { scl = 0; }
				ref.Broadcaster.broadcastMessage("onSeekStart",[scl])
				//ns.seek(scl*ns.totalTime);
			}
		}
	};

	// stop playhead scrubbing
	private function playbackRelease():Void { 
		if(_seekenabled){
			delete playback.onEnterFrame;
			Broadcaster.broadcastMessage("onSeekStop",[getProgress()])
			//pauseBut._visible == false ? videoDisplay.pause() : null;
		}
	};
}