/**
* @class	Environment static class
* This class provides methdos to determine the current application Environment: Flash Test Movie mode, 
* and domain where the current swf file is running from.
* @author	Federico Campo Piombi
* @version	1.0
* @date 	11 Oct 2006
*/

class com.fwa.debug.Environment {
	
	/**
	* Stores a list of the allowed domains entered using allowDomain
	*/
	private static var domains_allowed:Array = []
	
	
	/**
	* @CONSTRUCTOR
	*/
	private function Environment(){}
	
	/**
	* @method	isFlash
	* @tooltip	Returns true if running in Flash Test Movie mode. Otherwise retuns false.
	* @return	Boolean
	*/
	public static function isFlash():Boolean {
		return ((System.capabilities.playerType == "External")? true : false)
	}
	
	/**
	* @method	isAllowed
	* @tooltip	Returns true if movie is running in any of the allowed Domains. Otherwise returns false.
	* @return	Boolean
	*/
	public static function isAllowed():Boolean {
		var c_domain:String = getDomain()
		for(var i:Number = 0; i<domains_allowed.length; i++){
			if(domains_allowed[i] == c_domain){
				return(true)
			}
		}
		return(false)
	}
	
	/**
	* @method	getDomain
	* @tooltip	Returns the current domain where the site is running
	* @return	String
	*/
	public static function getDomain():String {
		var url:String = _root._url
		if(url.indexOf("file://")!==-1){
			return("file")
		}else{
			var protocol:String = url.substring(0,url.lastIndexOf("//")+2)
			var url_rest:String = url.substring(protocol.length, url.length)
			var dmn:String = url_rest.substring(0, url_rest.indexOf("/"))
			return(dmn)
		}
	}
	
	/**
	* @method	allowDomain
	* @tooltip	Adds a Domain to the domains_allowed list.
	* 			isTest will return FALSE if the current domain is found in that list
	* @return	String
	*/
	public static function allowDomain(dmn:String):Void {
		domains_allowed.push(dmn)
	}
}