import com.fwa.system.FWAConfiguration;
import com.fwa.data.NodeRetriever;

/**
* Static class Language
* This class works as an API to retrieve the labels for the Marco, of the selected language
* 
* @version 	1.0
* @date 	30 Nov 2006
*/
class com.fwaapi.Language {
	
	/**
	* Constructor 
	*/
	private function Language(){}
	
	/**
	* This method returns a String with the content of the given miscelanea identifier
	* @param	identifier (String) Identifier of the subtitle
	* @return	String
	*/
	public static function getLabel(identifier:String):String {
		var content:String = getNodeContent(identifier)
		return(content)
	}
	
	
	//PRIVATE METHODS
	/**
	* Retrieves the given node's identifier content text.
	* @param	identifier (String) Identifier of the node whose content needs to be retrieved
	* @return	String
	*/
	private static function getNodeContent(identifier:String):String {
		var obj:Object = FWAConfiguration.main.labels
		var node:Object = NodeRetriever.retrieveFirstNode(identifier, obj.label)
		var node_content:String = node.content._value
		
		return( (node_content==undefined)? "" : node_content )
	}
}