import com.fwa.system.FWAConfiguration;
import com.fwaapi.Language;
import com.fwamarco.consoles.AbstractConsole;
import com.fwamarco.consoles.ConsolesManager;
import mx.utils.Delegate;

class com.fwamarco.consoles.Login extends AbstractConsole {
	
	//layout elements
	private var clip_bg:MovieClip;
	private var bt_close:Button;
	private var bt_login:Button;
	private var i_username:TextField;
	private var i_password:TextField;
	private var t_incorrecto:TextField;
	private var t_title_login:TextField;
	private var t_title_user:TextField;
	private var t_title_pass:TextField;
	
	//properties
	private var autologin:Boolean = true;
	private var isLogged:Boolean;
	private var true_user:String;
	private var true_pass:String;
	
	/**
	* Constructor
	*/
	public function Login(){
		t_incorrecto._visible = false
		bt_close.onRelease = Delegate.create(ConsolesManager, ConsolesManager.closeAll);
		bt_login.onRelease = Delegate.create(this, performLogin);
		
		//store username & pass
		true_user = FWAConfiguration.main.accesibility.login.user._value
		true_pass = FWAConfiguration.main.accesibility.login.pass._value
		
		
		//assign tabindexes
		i_username.tabIndex = 1;
		i_password.tabIndex = 2;
		bt_login.tabIndex = 3;
		
		initTextFields();
	}
	
	/**
	* Overrides the default show method to perform AutoLogin
	*/ 
	/*
	public function show():Void {
		super.show();
		autoLogin();
	}
	*/
	
	/**
	* Initialises the consoles TextFields content from the main language file
	* Updates the display properties of the related elements
	*/
	private function initTextFields():Void {
		//get TextFormats
		var tf_titulo:TextFormat = t_title_login.getTextFormat();
		var tf_user:TextFormat = t_title_user.getTextFormat();
		var tf_pass:TextFormat = t_title_pass.getTextFormat();
		var tf_error:TextFormat = t_incorrecto.getTextFormat();
		
		//apply labels
		t_title_login.text = Language.getLabel("login_titulo");
		t_title_user.text = Language.getLabel("login_usuario");
		t_title_pass.text = Language.getLabel("login_pass");
		t_incorrecto.text = Language.getLabel("login_error");
		
		//apply TextFormats
		t_title_login.setNewTextFormat(tf_titulo);
		t_title_user.setNewTextFormat(tf_user);
		t_title_pass.setNewTextFormat(tf_pass);
		t_incorrecto.setNewTextFormat(tf_error);
	}
	
	/**
	* Performs the User login. 
	* Displays the Logs console if the user logged successfuly
	*/
	private function performLogin():Void {
		t_incorrecto._visible = false
		isLogged = false
		
		if(validateUser(i_username.text, i_password.text)==true){
			isLogged = true
			ConsolesManager.displayConsole("consola_logs")
		}else{
			t_incorrecto._visible = true
			i_username.text = ""
			i_password.text = ""
		}
	}
	
	/**
	* Validates the given Username and Passwords, and returns true if match
	* Validation is CaseSensitive.
	* @param	user (String) user name
	* @param	pass (String) user pass
	* @return	Boolean
	*/
	private function validateUser(user:String, pass:String):Boolean {
		if(user==true_user && pass==true_pass){
			return(true)
		}else{
			return(false)
		}
	}
	
	/**
	* Automatically logs the User in
	*/
	private function autoLogin():Void {
		if(autologin==true && isLogged==true){
			ConsolesManager.closeAll();
			ConsolesManager.displayConsole("consola_logs");
		}else{
			i_username.text = "";
			i_password.text = "";
		}
	}
	
}