import com.fwa.system.FWAConfiguration;
import com.fwa.controllers.ScrollPane;
import mx.utils.Delegate;

/**
* This class handles the view of the Language Selector console in the Marco.
* 
* @version	 1.0
* @since	17 Mar 2007
*/
class com.fwamarco.ui.LangSelector extends MovieClip {
	//LAYOUT ELEMENTS
	private var clip_list:MovieClip;
	
	
	/**
	* Starts the selector invisible.
	*/
	public function LangSelector(){
		this._visible = false
	}
	
	
	/**
	* Executed on the second frame of the LangSelector clip.
	* Starts creating the languages lists (if many), otherwises executes the event
	* for the default language
	*/
	public function init():Void {
		var scrollPane:ScrollPane = ScrollPane(clip_list);
		
		var langs:Array = FWAConfiguration.main.languages.lang
		if(langs.length>1){
			//langs
			scrollPane.removeAll();
			
			for(var i:Number = 0; i<langs.length; i++){
				var ref:LangSelector = this;
				var item_name:String = "lang"+i
				var item:MovieClip = scrollPane.addItem("item_otherlang", item_name, 0, clip_list.getHeight())
				updateAfterEvent()
				item.label = langs[i].name._value
				item.datos = langs[i]
				item.onSelect = function(oLang:Object):Void {
					ref.onLanguageSelected(oLang.folder._value, oLang.language_file._value);
				}
			}
			this._visible = true
		}else{
			onLanguageSelected(langs[0].folder._value, langs[0].language_file._value);
		}
	};
	
	
	//EVENTS
	/**
	* Event executed when a language is selected.
	* @param	folder (String) Language folder inside the application
	* @param	file (String) Language file for the Marco labels and applications list
	*/
	public function onLanguageSelected(folder:String, file:String):Void {}
}