import com.parker.core.URLs;
import com.parker.core.Configuration;
import com.parker.users.User;
import com.parker.content.WindowsProxy;
import com.wunderman.forms.FormsProcessor;
import com.wunderman.utils.XMLConstruct;
import com.wunderman.debug.Environment;
import mx.utils.Delegate;

/**
* @class 	Registration
* @tooltip 	
* @author	Federico Campo Piombi
* @version 	1.0
* @date 	07 Nov 2006
*/
class com.parker.forms.Compra extends MovieClip {
	//properties
	private var fp:FormsProcessor;
	private var wproxy:WindowsProxy;
	
	//form fields
	private var i_nombre:TextField;
	private var i_direccion:TextField;
	private var i_ticket:TextField;
	private var cb_dia:MovieClip;
	private var cb_mes:MovieClip;
	private var cb_modelo:MovieClip;
	private var bt_send:Button;
	
	/**
	* @constructor
	*/
	public function Compra(){
		fp = new FormsProcessor();
		wproxy = WindowsProxy.getInstance();
	}
	
	//public methods
	
	/**
	* @method 	init
	* @tooltip 	Initialises form variables
	* @return 	Void
	*/
	public function init():Void {
		initProcessor()
		fillCombos()
		bt_send.onRelease = Delegate.create(this, sendForm)
	}
	
	
	//private methods
	
	/**
	* @method 	sendForm
	* @tooltip 	Submits the registration Form
	* @return	Void
	*/
	private function sendForm():Void {
		if(fp.isValid()){
			var ref = this
			var send_lv:LoadVars = new LoadVars();
			var receive_lv:LoadVars = new LoadVars();
			
			//definir el receiver
			receive_lv.onLoad = function(){
				switch(this.msg){
					case "0":
						User.updateChances(User.getChances()+1)
						var cback:Object = new Object()
						cback.onClose = Delegate.create(ref, ref.onCompraFinished)
						ref.wproxy.openAlert("FELICITACIONES!", "Tu ticket se envi con xito!", "alert", cback)
						break;
					case "6":
						ref.wproxy.openAlert("ATENCION!", "Debes estar logueado para enviar tu ticket!", "alert");
						break;
					default:
						ref.wproxy.openAlert("ATENCION!", "Error desconocido: "+this.msg, "alert");
						break;
				}
			}
			
			//definir el sender
			send_lv.comercio_nombre = i_nombre.text;
			send_lv.comercio_direccion = i_direccion.text;
			send_lv.ticket = i_ticket.text;
			send_lv.dia_compra = cb_dia.getValue();
			send_lv.mes_compra = cb_mes.getValue();
			send_lv.modelo = cb_modelo.getValue();
			
			//enviar
			send_lv.sendAndLoad(URLs.compra, receive_lv, "POST")
			
		}else{
			var err:Object = fp.getError()
			var err_msg:String = (err.type!=="combo" && err.type!=="checkbox")? err.name : err.error
			wproxy.openAlert("ATENCION!", err_msg, "alert");
		}
	}
	
	
	/**
	* @method 	initProcessor
	* @tooltip 	Registers the Form's fields into the FormsProcessor
	* @return	Void
	*/
	private function initProcessor():Void {
		fp.addField(i_nombre, "text","Debes ingresar el nombre del comercio","A-Z a-z 0-9 \\-_.", 150);
		fp.addField(i_direccion, "text", "Debes ingresar la direccin del comercio", "A-Z 0-9 a-z.'", 150);
		fp.addField(i_ticket, "number", "Debes ingresar un ticket vlido", "A-Za-z0-9.\\-", 50);
		
		fp.addCombo(cb_mes, -1, "Debes seleccionar el mes de nacimiento");
		fp.addCombo(cb_dia, -1, "Debes seleccionar el da de nacimiento");
		
		fp.setDefaultErrorMessage("Debes completar todos los campos")
		fp.clearFields()
	}
	
	/**
	* @method 	fillCombos
	* @tooltip 	Loads the data into the combos
	* @return 	Void
	*/
	private function fillCombos():Void {
		//fill dates
		for(var i:Number = 1; i<=31; i++){
			cb_dia.addItem(i, i)
		}
		
		for(var i:Number = 1; i<=12; i++){
			cb_mes.addItem(i,i)
		}
		
		var modelos:Object = Configuration.getModelos().modelo
		var mcount:Number = modelos.length
		for(var i:Number=0; i<mcount; i++){
			cb_modelo.addItem(modelos[i].nombre._value, modelos[i].id._value)
		}
	}
	
	/**
	* @method 	parseResponse
	* @tooltip 	Converts a LoadVars XML-like response into an object
	* @param	str (String) LoadVars receipt
	* @return	Object
	*/
	private function parseResponse(str:String):Object {
		trace("str: "+str)
		var xmlstr:String = str.substring(0, str.indexOf("="))
		xmlstr = xmlstr.split("\n").join("")
		trace("xmlstr: "+xmlstr)
		var tXML:XML = new XML(xmlstr)
		tXML.ignoreWhite = true
		trace("xml: "+tXML)
		var oXML:Object = new XMLConstruct(tXML)
		return (oXML)
	}
	
	
	//events
	/**
	* @event	onRegistrationFinished
	* @tooltip 	Event executed when the user has finished his Registration with no errors
	*/
	private function onCompraFinished():Void {
		_parent.gotoAndPlay("exito")
	}
}