﻿/**
* @version 		StoredActions Class 1.1
* @author 		Federico Campo Piombi
* @date 		2006/09/06
* @description 	Clase que maneja la recepci conversion de StoredActions
*/
import com.wunderman.crypt.Base64

class com.wunderman.utils.StoredActions {
	/**
	* @property _instance
	* @tooltip Stores the Singleton instance
	* @type StoredActions
	*/
	private static var _instance:StoredActions = null;
	
	private var _action:String
	private var _params:Array
	
	
	
//CONSTRUCTOR
	private function StoredActions() {
		_global.tb.trace("_level0.action: "+_level0.action);
		if(_level0.action && _level0.action!==""){
			_action = _level0.action 
			delete _level0.action
		}
		if(_level0.action_params && _level0.action_params!==""){
			_params = Base64.Decode(_level0.action_params).split(",")
			delete _level0.action_params
		}
	}

// PUBLIC methods:

	/**
	* @method getInstance
	* @tooltip Resturns a reference to the Singleton StoredActions class
	* @return StoredActions
	*/
	public static function getInstance():StoredActions {
		if(StoredActions._instance == null){
			StoredActions._instance = new StoredActions()
		}
		return(StoredActions._instance)
	}
	
	/**
	* @method getAction
	* @tooltip Returns the stored Action
	* @return String
	*/
	public function getAction():String {
		return(_action)
	}
	
	/**
	* @method getParams
	* @tooltip Returns the stored action Params
	* @return Array
	*/
	public function getParams():Array {
		return(_params)
	}
	
	/**
	* @method hasActions()
	* @tooltip Returns TRUE if there's a stored Action
	* @return Boolean
	*/
	public function hasActions():Boolean {
		return( (_action!==undefined)? true : false )
	}
	
	/**
	* @method dismiss()
	* @tooltip Destroys stored Action and Params
	* @return Void
	*/
	public function dismiss():Void {
		_action = undefined
		_params = undefined
	}
}