/*
Copyright 2005 Midnight Coders, LLC

Licensed under the Midnight Coders license (the "License");
You may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.themidnightcoders.com/licensing/asdklicense.htm

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

import asdk.*;
import asdk.condition.*;
import asdk.functions.*;

dynamic class asdk.algorithm.Counting
{
	static function count( collection : Collection, valueObj ) : Number
	{
		return countIf( collection, new EqualsObject( valueObj ) );
	}
	
	static function countIf( collection : Collection, condition : UnaryCondition ) : Number
	{
		var counter : Number = 0;
		var iterator : Iterator = collection.iterator();
		
		while( iterator.hasNext() )
			if( condition.execute( iterator.getNext() ) )
				counter++;
		
		return counter;		
	}
	
	static function accumulate( collection : Collection, functionObj : BinaryFunction )
	{
		if( functionObj == undefined )
		  functionObj = new Addition();
		
		var iterator : Iterator = collection.iterator();
		var result : Number = 0;
		
		while( iterator.hasNext() )
			result = functionObj.execute( result, iterator.getNext() );
			
		return result;
	}
}