import com.fwa.system.processes.ISystemProcess;
import com.fwa.system.gateway.ExternalData;
import com.fwa.system.Configuration;
import com.fwa.system.FWAConfiguration;
import com.fwa.debug.Tracer;
import mx.utils.Delegate;

/**
* LoadSounds (System Process)
* This class loads the Sounds XML file and stores it into the Configuration under the "sounds" identifier
* @author	Federico Campo Piombi [federicocp@hotmail.com]
* @version	1.0
* @date 	22 Nov 2006
*/
class com.fwa.system.processes.LoadSounds implements ISystemProcess {
	
	//PROPERTIES
	private var inited:Boolean
	
	
	/**
	* Constructor
	*/
	public function LoadSounds(){
		inited = false
	}
	
	/**
	* Initialises the process: Starts loading the accesibility file usign ExternalData
	*/
	public function init():Void {
		if(inited == false){
			inited = true
			onProcessStarted(1)
			
			var acc:ExternalData = new ExternalData()
			var app_path:String = FWAConfiguration.application
			
			acc.filename = app_path+"/sounds.xml"
			acc.onLoad = Delegate.create(this, this.elementLoaded)
			acc.onLoadError = Delegate.create(this, this.onProcessAborted)
			acc.load()
		}
	}
	
	/**
	* @return	String
	*/
	public function toString():String {
		return("LoadSounds")
	}
	
	/**
	* This method is executed every time an external configuration file is loaded
	* @param	data (Object) The data object loaded
	* @param	filename (String) The name of the loaded file
	*/
	private function elementLoaded(data:Object, filename:String):Void {
		//add this element to the Configuration
		Configuration.store("sounds", data)
		onProcessUpdated(1,1)
		onProcessCompleted()
	}
	
	
	//EVENTS
	public function onProcessStarted(total_subprocesses:Number):Void {}
	public function onProcessUpdated(current_subprocess:Number, total_subprocesses:Number):Void {}
	public function onProcessCompleted():Void {}
	public function onProcessAborted(reason:String):Void {}
}