﻿import mx.utils.Delegate
class com.fwamarco.ui.MessageBox extends MovieClip {
	
	//COMPONENTS/////////////////////////////////////////////////////////////
	private var feedback_bg:Button
	private var msg_bg:MovieClip
	private var banner_miami:MovieClip
	private var txt_title:TextField
	private var txt_message:TextField
	private var bt_close:Button
	private var bt_ok:Button
	private var bt_cancel:Button
	private var xt_content:MovieClip
	
	//PROPERTIES/////////////////////////////////////////////////////////////
	private var callbacks:Object
	
	//CONSTRUCTOR////////////////////////////////////////////////////////////
	public function MessageBox(){
		feedback_bg.enabled = feedback_bg.useHandCursor = false
		
		bt_close.onRelease = Delegate.create(this, this.onClose)
		bt_ok.onRelease = Delegate.create(this, this.onOk)
		bt_cancel.onRelease = Delegate.create(this, this.onCancel)
		
		this.onHideDone()
	}
	
	public function load(filename:String, w:Number, h:Number, modo:String, cbacks:Object):Void {
		this._visible = true
		//apagar todo
		txt_title.text = ""
		txt_message.text = ""
		msg_bg._visible = false
		setMode("none")
		
		//cargar el contenido
		xt_content = this.createEmptyMovieClip("xt_content", 10)
		var ref:MovieClip = this
		var mcl:MovieClipLoader = new MovieClipLoader()
		var mcl_lst:Object = new Object()
		mcl_lst.onLoadStart = function(tmc:MovieClip){
			tmc._visible = false
			tmc.stop()
		}
		mcl_lst.onLoadInit = function(tmc:MovieClip){
			tmc._visible = true
			tmc.gotoAndPlay(1)
			var ref2:MovieClip = ref
			var t_int:Number
			var exec:Function = function(){
				clearInterval(t_int)
				ref2.setMode(modo)
			}
			t_int = setInterval(exec, 3000)
		}
		
		//Load
		centerContent(w,h)
		mcl.addListener(mcl_lst)
		mcl.loadClip(filename, xt_content)
		callbacks = cbacks
	}
	
	public function show(sTitle:String, sMessage:String, modo:String, callbacks:Object):Void {
		//clear xternal content clip
		xt_content.removeMovieClip()
		//save callbacks
		this.callbacks = callbacks
		//add texts
		txt_title.text = sTitle.toUpperCase()
		txt_message.text = sMessage.toUpperCase()
		txt_message.autoSize = true
		
		//autosize messagebox
		//msg_bg._height = (txt_message._height<45)? 100 : txt_message._height+60
		msg_bg._width = 350
		msg_bg._x = 200
		msg_bg._y = 148
		msg_bg._height = (txt_message._y+txt_message._height-msg_bg._y)+(bt_ok._height*2)+10
		
		//apply mode
		this.setMode(modo)
		
		if(this._visible == false){
			this._visible = true
			//this._alpha = 0
			//this.alphaTo(100,0.5,"easeOutQuint")
		}
	}
	
	public function hide():Void {
		if(this._visible == true){
			//this.alphaTo(0,0.5,"easeOutQuint",0,{func:this.onHideDone, scope:this})
			this.onHideDone()
		}
	}
	
	private function onHideDone():Void {
		this._visible = false
	}
	
	private function setMode(modo:String):Void {
		var margin_bottom:Number = 5
		var margin_right:Number = 5
		banner_miami._visible = false
		
		switch (modo.toLowerCase()){
			default:
			case "close":
				bt_close._visible = true
				bt_ok._visible = bt_cancel._visible = false
				break;
			case "ok":
				bt_close._visible = false
				bt_cancel._visible = false
				bt_ok._visible = true
				bt_ok._x = this.getBGBounds().right - (bt_ok._width+margin_right)
				bt_ok._y = this.getBGBounds().bottom - (bt_ok._height+margin_bottom)
				break;
			case "cancel":
				bt_close._visible = false
				bt_ok._visible = false
				bt_cancel._visible = true
				bt_cancel._x = this.getBGBounds().right - (bt_cancel._width+margin_right)
				bt_cancel._y = this.getBGBounds().bottom - (bt_cancel._height+margin_bottom)
				break;
			case "okcancel":
				bt_close._visible = false
				bt_ok._visible = true
				bt_cancel._visible = true
				bt_ok._x = this.getBGBounds().right - (bt_ok._width+margin_right)
				bt_ok._y = this.getBGBounds().bottom - (bt_ok._height+margin_bottom)
				bt_cancel._x = bt_ok._x - (bt_cancel._width + margin_right)
				bt_cancel._y = this.getBGBounds().bottom - (bt_cancel._height+margin_bottom)
				break;
			case "none":
				bt_close._visible = false
				bt_ok._visible = false
				bt_cancel._visible = false
				break;
			case "miami":
				setMode("ok")
				bt_ok._visible = false
				bt_ok._y = banner_miami._y + 135
				banner_miami._visible = true
				banner_miami.gotoAndPlay(1)
				msg_bg._height = 305
				break;
		}
	}
	
	private function centerContent(banner_w:Number, banner_h:Number):Void {
		xt_content._x = Math.round((feedback_bg._width/2)-(banner_w/2))
		xt_content._y = Math.round((feedback_bg._height/2)-(banner_h/2))-30
		msg_bg._x = xt_content._x-5
		msg_bg._y = xt_content._y-5
		msg_bg._width = banner_w + 10
		msg_bg._height = banner_h+35
		msg_bg._visible = true
	}
	
	
	private function onOk():Void {
		this.hide()
		callbacks.ok_func.apply(callbacks.ok_scope, callbacks.ok_args)
	}
	private function onCancel():Void {
		this.hide()
		callbacks.cancel_func.apply(callbacks.cancel_scope, callbacks.cancel_args)
	}
	private function onClose():Void {
		this.hide()
		callbacks.close_func.apply(callbacks.close_scope, callbacks.close_args)
	}
	
	private function getBGBounds():Object {
		var obj:Object = new Object()
		obj.top = msg_bg._y
		obj.bottom = msg_bg._y + msg_bg._height
		obj.left = msg_bg._x
		obj.right = msg_bg._x + msg_bg._width
		return (obj)
	}
	
}
