import com.wunderman.debug.Environment;
import com.wunderman.debug.Tracer;

/**
* @class	URLs (Static)
* @tooltip	This class stores URL addresses for external comunication calls
* @author	Federico Campo Piombi
* @version	1.0
* @date		01 Nov 2006
*/
class com.parker.core.URLs {
	
	private static var _basepath:String
	private static var _backgrounds:String
	private static var _login:String
	private static var _registration:String
	private static var _compra:String
	
	/**
	* @constructor
	*/
	private function URLs(){}

	/**
	* @method	init
	* @tooltip	Initialises the URL addresses (used to differentiate between Debug Mode or Live Mode)
	*/
	public static function init():Void {
		Tracer.output("","init","URLs")
		var debug:Boolean = (Environment.isTestMovie())? true : false
		
		_basepath 		= (debug)? "http://apuntaalto.wavenet.com.ar/usuarios.php" : ""
		_backgrounds 	= "imgs/"
		_registration	= _basepath + "?ac=registrar"
		_login			= _basepath + "?ac=login"
		_compra			= _basepath + "?ac=agregarcod"
		
	}
	
	//GETTERS
	public static function get basepath():String {return _basepath};
	public static function get backgrounds():String {return _backgrounds};
	public static function get login():String {return _login};
	public static function get registration():String {return _registration};
	public static function get compra():String {return _compra};
}