import com.parker.users.User;
import com.parker.core.URLs;
import com.parker.core.Configuration;
import com.parker.content.WindowsProxy;
import com.wunderman.forms.FormsProcessor;
import com.wunderman.utils.XMLConstruct;
import mx.utils.Delegate;

/**
* @class 	Registration
* @tooltip 	
* @author	Federico Campo Piombi
* @version 	1.0
* @date 	07 Nov 2006
*/
class com.parker.forms.Login extends MovieClip {
	//properties
	private var fp:FormsProcessor;
	private var wproxy:WindowsProxy;
	
	//form fields
	private var i_email:TextField;
	private var i_pass:TextField;
	private var bt_send:Button;
	
	/**
	* @constructor
	*/
	public function Login(){
		fp = new FormsProcessor();
		wproxy = WindowsProxy.getInstance();
	}
	
	//public methods
	
	/**
	* @method 	init
	* @tooltip 	Initialises form variables
	* @return 	Void
	*/
	public function init():Void {
		initProcessor()
		bt_send.onRelease = Delegate.create(this, sendForm)
	}
	
	
	//private methods
	
	/**
	* @method 	sendForm
	* @tooltip 	Submits the registration Form
	* @return	Void
	*/
	private function sendForm():Void {
		if(fp.isValid()){
			var ref = this
			var send_lv:LoadVars = new LoadVars();
			var receive_lv:LoadVars = new LoadVars()
			
			//definir el receiver
			receive_lv.onLoad = function(success:Boolean){
				if(success){
					var parsed:Object = ref.parseResponse(unescape(this))
					switch(parsed.error._value){
						case "0":
							User.login(parsed)
							ref.onLoginFinished();
							break;
						case "2":
							ref.wproxy.openAlert("ATENCION", "Usuario inexistente", "alert");
							break;
						default:
							trace("UNKNOWN RESULT:"+parsed.error._value)
							break;
					}
				}else{
					ref.wproxy.openAlert("ATENCION!", "No se puede ejecutar el login!", "alert")
				}
			}
			
			//definir el sender
			send_lv.email = i_email.text;
			send_lv.contrasena = i_pass.text;
			
			//enviar
			send_lv.sendAndLoad(URLs.login, receive_lv, "POST")
			
		}else{
			var err:Object = fp.getError()
			var err_msg:String = (err.type!=="combo" && err.type!=="checkbox")? err.name : err.error
			wproxy.openAlert("ATENCION!", err_msg, "alert");
		}
	}
	
	/**
	* @method 	initProcessor
	* @tooltip 	Registers the Form's fields into the FormsProcessor
	* @return	Void
	*/
	private function initProcessor():Void {
		fp.addField(i_email, "email", "E-Mail invlido", "A-Z0-9a-z@._\\-", 150);
		fp.addField(i_pass,"text","Password invlido","",150);
		
		fp.setDefaultErrorMessage("Debes completar todos los campos obligatorios")
		fp.clearFields()
	}
		
	/**
	* @method 	parseResponse
	* @tooltip 	Converts a LoadVars XML-like response into an object
	* @param	str (String) LoadVars receipt
	* @return	Object
	*/
	private function parseResponse(str:String):Object {
		var xmlstr:String = str.substring(0, str.indexOf("="))
		xmlstr = xmlstr.split("\n").join("")
		
		var tXML:XML = new XML(xmlstr)
		tXML.ignoreWhite = true
		
		var oXML:Object = new XMLConstruct(tXML)
		return (oXML)
	}
	
	
	//events
	/**
	* @event	onRegistrationFinished
	* @tooltip 	Event executed when the user has finished his Registration with no errors
	*/
	private function onLoginFinished():Void {
		trace("login finished")
		_parent.gotoAndPlay("exito")
	}
}