/**
* @version 		Wunderman Environment static class 1.0
* @author 		Federico Campo Piombi
* @date 		2006 Oct. 11
* @description 	Esta clase provee metodos para determinar el entorno general de la aplicacion
* 				Utilizar el metodo <allowDomain> para agregar dominios que funcionan como Produccion.
* 				De esta manera, al invocar <isTest>, este retornara TRUE si el dominio en que esta corriendo
* 				la aplicacion ppal no corresponde a los dominios especificados como Produccion.
* @revision		N/A
*/

class com.wunderman.debug.Environment {
	
	private static var domains_allowed:Array = []
	
	
	/**
	* @CONSTRUCTOR
	*/
	private function Environment(){}
	
	/**
	* @method	isTestMovie
	* @tooltip	Returns TRUE if running in Test Movie mode
	* @return	Boolean
	*/
	public static function isTestMovie():Boolean {
		return ((System.capabilities.playerType == "External")? true : false)
	}
	
	/**
	* @method	isTest
	* @tooltip	Returns TRUE if movie is not running in any of the allowed Domains
	* @return	Boolean
	*/
	public static function isTest():Boolean {
		var c_domain:String = getDomain()
		for(var i:Number = 0; i<domains_allowed.length; i++){
			if(domains_allowed[i] == c_domain){
				return(false)
			}
		}
		return(true)
	}
	
	/**
	* @method	getDomain
	* @tooltip	Returns the current domain where the site is running
	* @return	String
	*/
	public static function getDomain():String {
		var url:String = _root._url
		if(url.indexOf("file://")!==-1){
			return("file")
		}else{
			var protocol:String = url.substring(0,url.lastIndexOf("//")+2)
			var url_rest:String = url.substring(protocol.length, url.length)
			var dmn:String = url_rest.substring(0, url_rest.indexOf("/"))
			return(dmn)
		}
	}
	
	/**
	* @method	allowDomain
	* @tooltip	Adds a Domain to the domains_allowed list.
	* 			isTest will return FALSE if the current domain is found in that list
	* @return	String
	*/
	public static function allowDomain(dmn:String):Void {
		domains_allowed.push(dmn)
	}
}