/*
Copyright 2005 Midnight Coders, LLC

Licensed under the Midnight Coders license (the "License");
You may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.themidnightcoders.com/licensing/asdklicense.htm

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

import asdk.*;

class asdk.ObjectComparator implements IComparator
{
	static function equals( obj1, obj2 ) : Boolean
	{
		var oc:ObjectComparator = new ObjectComparator()
		return oc.equal( obj1, obj2 );
	}
	
	public function equal( obj1, obj2 ) : Boolean
	{
        if( obj1 == undefined && obj2 == undefined )
            return true;
            
		if( typeof( obj1 ) == "function" && 
		    typeof( obj2 ) == "function" &&
			obj1.toString() == obj2.toString() )
			return true;
			
		if( typeof( obj1 ) != typeof( obj2 ) )
    		return false;
		
		if( typeof( obj1[ "equals" ] ) == "function" )
		{
			//trace( "delegating to object's equal method" );
			return obj1.equals( obj2, this );
		}

		for( var name:String in obj1 )
		{
			//if( obj2[ name ] == undefined )
			//	return false;
	
			//trace( "checking field " + name  + "  " + obj1[ name ] + "  " + obj2[ name ] );
			if( !( equals( obj1[ name ], obj2[ name ] ) ) )
				return false;
		}
		
		// array check
		if( obj1.length != null && 
		   typeof( obj1.pop ) == "function" &&
		   obj2.length != null &&
		   typeof( obj2.pop ) == "function" )
		{
			// if the length of the arrays is different, the objects are not equal
			if( obj1.length != obj2.length )
			{
			  return false;
			}
			else
			{
		      // iterate over the array elements and recurse this function for each element
			  for( var i = 0; i < obj1.length; i++ )
			    if( !equals( obj1[ i ], obj2[ i ] ) )
				  return false;
			  
			  return true;
			}
		}										  
		
		// if it is not an object or array, use basic equality operator
		if( typeof( obj1 ) != "object" )
			return obj1 == obj2;
		else
			return true;
	}
}

