/*
Copyright 2005 Midnight Coders, LLC

Licensed under the Midnight Coders license (the "License");
You may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.themidnightcoders.com/licensing/asdklicense.htm

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

import asdk.*;

class asdk.Stack extends AbstractCollection
{
	private var list : LinkedList;
	
	function Stack()
	{
		this.list = new LinkedList();
	}
	
	function New() : Collection
	{
		return new Stack();
	}	
	
	function push( object )
	{
		addItem( object );
		return object;
	}
	
	function pop()
	{
		var size : Number = getSize();
		
		if( size == 0 )
		{
			throw new Error( "stack is empty, cannot pop" );
		}
		var object = peek();
		list.removeFirst();
		return object;
	}
	
	function peek()
	{
		var size = getSize();
		
		if( size == 0 )
		{
			throw new Error( "stack is empty, cannot peek" );
			return null;
		}
		
		return list.getFirst().getData();
	}
	
	function addItem( item ) : Boolean
	{
		list.insertItemAt( 0, item );
		return true;
	}
	
	function iterator() : Iterator
	{
		return list.dataIterator();
	}

	function getSize() : Number
	{
		return list.getSize();
	}	
}