/*
Copyright 2005 Midnight Coders, LLC

Licensed under the Midnight Coders license (the "License");
You may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.themidnightcoders.com/licensing/asdklicense.htm

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

import asdk.condition.*;

class asdk.condition.UnaryTern implements UnaryCondition
{
    private var conditionIf : UnaryCondition;
    private var conditionThen : UnaryCondition;
    private var conditionElse : UnaryCondition;
	
    function UnaryTern( conditionIf : UnaryCondition, conditionThen : UnaryCondition, conditionElse : UnaryCondition )
	{
        this.conditionIf = conditionIf;
        this.conditionElse = conditionElse;
        this.conditionThen = conditionThen;
	}
	
	function execute( operand ) : Boolean
	{
        if( conditionIf.execute( operand ) )
            return conditionThen.execute( operand );
		else
            return conditionElse.execute( operand );   
	}
}