/*
Copyright 2005 Midnight Coders, LLC

Licensed under the Midnight Coders license (the "License");
You may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.themidnightcoders.com/licensing/asdklicense.htm

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

import asdk.*;

class asdk.iterator.LinkedListIterator implements Iterator
{
    private var list;
    private var curItem : LinkedListItem;
    private var returnData : Boolean;

    function LinkedListIterator( list, returnData : Boolean )
    {
        this.list = list;
        this.returnData = returnData;
    }

    function hasNext() : Boolean
    {
        if( curItem == null )
          return list.getFirst() != null;
        else
          return curItem.next != null;
    }

    function getNext()
    {
        if( curItem == null )
            curItem = list.getFirst();
        else
            curItem = curItem.next;

        if( returnData )
            return curItem.getData();
        else
            return curItem;
    }

    function remove() : Void
    {
        if( curItem.prev == undefined )
            list.head = curItem.next;
        else
            curItem.prev.next = curItem.next;

        if( curItem.next == undefined )
            list.tail = curItem.prev;
        else
            curItem.next.prev = curItem.prev;
    }
}
