import com.fwa.system.Configuration;

/**
* Static class FWAConfiguration
* This class provides methods to access directly to several stored configuration values.
* 
* @version	1.9
* @since 	15 Nov 2006
*/
class com.fwa.system.FWAConfiguration {
	
	/**
	* Hidden Constructor
	*/
	private function FWAConfiguration(){}
	
	
	
	//public methods
	public static function setLang(){}
	
	
	
	//GETTERS
	/**
	* Retrieves an Object with the application configuration file data
	* @return	Object
	*/
	public static function get configuration():Object {
		return Configuration.retrieve("configuration")
	}
	
	/**
	* Retrieves an Object with the application subtitles file data
	* @return	Object
	*/
	public static function get subtitles():Object {
		return Configuration.retrieve("subtitles")
	}
	
	/**
	* Retrieves an Object with the application accesibility file data
	* @return	Object
	*/
	public static function get accesibility():Object {
		return Configuration.retrieve("accesibility")
	}
	
	/**
	* Retrieves an Object with the application miscelaneas file data
	* @return	Object
	*/
	public static function get miscelaneas():Object {
		return Configuration.retrieve("miscelaneas")
	}
	
	/**
	* Retrieves an Object with the application sounds file data
	* @return	Object
	*/
	public static function get sounds():Object {
		return Configuration.retrieve("sounds")
	}
	
	/**
	* Retrieves an Object with the application resources file data
	* @return	Object
	*/
	public static function get resources():Object {
		return Configuration.retrieve("resources")
	}
	
	/**
	* Retrieves an Object with the Main Configuration
	* @return	Object
	*/
	public static function get main():Object {
		return Configuration.retrieve("mainconfig")
	}
	
	/**
	* Retrieves the System's selected Application language folder.
	* @return	String
	*/
	public static function get language():String {
		return String(Configuration.retrieve("selected_language"))
	}
	
	/**
	* Retrieves the System's selected language file (Marco labels and apps list)
	* @return String
	*/
	public static function get languageFile():String {
		return String(Configuration.retrieve("selected_language_file"));
	}
	
	/**
	* Retrieves the System's selected application path
	* @return	String
	*/
	public static function get application():String {
		return String(Configuration.retrieve("selected_application"))
	}
	
	/**
	* retrieves the System's selected application filename
	* @return	String
	*/
	public static function get applicationfile():String {
		return String(Configuration.retrieve("selected_application_file"))
	}
	
	/**
	* retrieves the System's selected application ID
	* @return	Number
	*/
	public static function get applicationID():Number {
		return Number(Configuration.retrieve("selected_application_id"));
	}
	
	
	/**
	* retrieves the System's Help content text
	* @return	String
	*/
	public static function get help():String {
		var hObj:Object = Configuration.retrieve("help")
		return String(hObj.content._value)
	}	
}