

class com.fwa.utils.Timer {
	
	private var init_time:Number
	
	/**
	* Constructor
	*/
	public function Timer(){
		init_time = getTimer()
	}
	
	/**
	* Retrieves the elapsed time (in milliseconds) between the current time, and the init_time
	* @return	Number
	*/
	public function getElapsed():Number {
		var elapsed:Number = getTimer() - init_time
		return(elapsed)
	}
	
	/**
	* Resets the time to Zero
	* @return	Void
	*/
	public function reset():Void {
		init_time = getTimer()
	}
	
	/**
	* Retrieves the elapsed time in an object form with the following values:
	* <li> hours: the elapsed number of hours </li>
	* <li> minutes: the elapsed minutes </li>
	* <li> seconds: the elapsed seconds </li>
	* <li> frac: the elapsed fraction of seconds </li>
	* 
	* @return	Object
	*/
	public function getElapsedObject():Object {
		var count:Number = 0.001*(getElapsed());
		
		var hours:Number     = Math.floor(count*0.00027777777777777);
		var remainder:Number = count - hours*3600.0;
		var minutes:Number   = Math.floor(remainder*0.0166666666666666667);
		var fSeconds:Number  = remainder - minutes*60;
		var seconds:Number   = Math.floor(fSeconds);
		var frac:Number      = fSeconds - seconds;
		frac                 = Math.floor(10*frac);
		
		//store values into time_data object
		var eObj:Object = new Object()
		eObj.hours = hours
		eObj.minutes = minutes
		eObj.seconds = seconds
		eObj.frac = frac
		
		return(eObj)
	}
}