import com.fwamarco.consoles.IConsole;

/**
* Static class ConsolesManager
* Provides control over the Consoles to avoid consoles overlapping.
* @author	Federico Campo Piombi [federicocp@hotmail.com]
* @version	1.0
* @date 	27 Nov 2006
*/

class com.fwamarco.consoles.ConsolesManager {
	//properties
	private static var consoles:Object = {};
	private static var current_console:IConsole = null;
	
	private function ConsolesManager(){};
	
	/**
	* Registers a Console in the list
	* @param	identifier (String) Identifier of the console (name by which the console will later be called)
	* @param	console (IConsole) The console to register
	* @return	Void
	*/
	public static function registerConsole(identifier:String, console:IConsole):Void {
		consoles[identifier] = console
	}
	
	/**
	* Displays the given console, and closes any previously open one
	* @param	identifier (String) Identifier of the console to open
	* @return	Void
	*/
	public static function displayConsole(identifier:String):Void {
		var c_console:IConsole = consoles[identifier]
		if(c_console!==undefined){
			closeAll()
			c_console.show()
			current_console = c_console
		}
	}
	
	/**
	* Closes all currently open consoles (technically, only 1 console can be opened at the time)
	* @return	Void
	*/
	public static function closeAll():Void {
		if(current_console !== null){
			current_console.hide()
			current_console = null
		}
	}
}