import mx.utils.Delegate
class com.parker.menu.dropdown.MenuManager extends MovieClip {
	
	private var menu_obj:Object
	
	public function MenuManager(){
	}
	
	public function init():Void {
	}
	
	public function createMenu(menu_object:Object):MovieClip {
		menu_obj = menu_object
		var mainmenu:MovieClip = attachMenu(menu_obj, "_MENU_ITEM", 0)
		mainmenu.show()
		return (mainmenu)
	}
	
	private function attachMenu(m_obj:Object, item_linkage:String, level:Number, parent_menu:MovieClip, parent_item:MovieClip):MovieClip {
		//trace("MMGR: attachMenu")
		//trace("  level:"+level)
		//trace("  parent:"+parent_menu)
		//trace(" ")
		
		level = (level==undefined || isNaN(level)==true || level<0)? 0 : level
		
		var menu_name:String = (level == 0)? "main_menu" : "submenu_"+this.getNextHighestDepth()
		var menu_clip:MovieClip = this.attachMovie("_MENU",menu_name,this.getNextHighestDepth())
		menu_clip.setParent(parent_menu, parent_item)
		
		var menu_items:Number = m_obj.section.length
		for(var i=0; i<menu_items; i++){
			var submenu:MovieClip
			var tOpt:Object = m_obj.section[i]
			var item:MovieClip = menu_clip.addItem(item_linkage, tOpt)
			item.onItemInitialised = Delegate.create(this, arrangeMenuItems)
			
			if(tOpt.submenu){ 
				submenu = attachMenu(tOpt.submenu, "_SUBMENU_ITEM", level+1, menu_clip, item)	
			}
			
			onMenuItemCreated(item, i, level)
			addMenuItemEvents(item, submenu, level)
		}
		
		onMenuCreated(menu_clip, level)
		menu_clip.show()
		return(menu_clip)
	}
	
	private function onMenuCreated(menu:MovieClip, menu_level:Number):Void {
		//trace("MMGR: onMenuCreated: "+menu._name)
		//trace(" ")
		var parent_item:MovieClip = menu.getParent().item
		var parent_menu:MovieClip = menu.getParent().menu
		
		switch (menu_level){
			case 0:
				menu._x = 10
				menu._y = 29
				break
			case 1:
 				menu._x = parent_item._x
				menu._y = parent_item._y + parent_item._height
				break;
			default:
				menu._x = parent_item._x + parent_item._width
				menu._y = parent_item._y + parent_item._height
				break;
		}
	}
	
	private function onMenuItemCreated(item:MovieClip, item_id:Number, menu_level:Number):Void {
		/*
		trace("MMGR: onMenuItemCreated")
		trace("  item:"+item._name+" level:"+menu_level)
		trace(" ")
		*/
		if(menu_level==0){
			//if it's a Main Menu item
			item._x = Math.ceil((item._width+5) * item_id)
			
		}else{
			//if it's a Submenu item
			item._y = item._height*item_id
		}
	}
	
	private function arrangeMenuItems(item:MovieClip):Void {
		var item_menu = item.getMenu()
		var menu_items:Array = item_menu.getItems()
		var itemscount:Number = menu_items.length
		
		for(var i:Number = 0; i<itemscount; i++){
			var mItem:MovieClip = menu_items[i]
			var pItem:MovieClip = menu_items[i-1]
			//trace("m:"+mItem._name+" p:"+pItem._name)
			mItem._x = (i==0)? 0 : Math.ceil(pItem._x+pItem._width+5)
		}
	}
	
	private function addMenuItemEvents(item:MovieClip, submenu:MovieClip, level:Number):Void {
		if(submenu!==undefined){
			//ITEM WITH SUBMENU EVENTS
			item.setChild(submenu)
			item.btarea.onRollOver = function(){
				//display child menu
				var child_menu:MovieClip = this._parent.getChild()
				child_menu.show()
				
				var cNode:Object = _global.config.menu_config.option
				this._parent.txt.textColor = cNode.color.over._value
				//this._parent.bg._alpha = Number(cNode.background.alpha_over._value)
				this._parent.bgColor.setRGB(Number(cNode.background.over._value))
			}
			item.btarea.onRollOut = function(override_mouse:Boolean){
				//if rolling out this button, and not rolling over child menu then hide child
				var child_menu:MovieClip = this._parent.getChild()
				if(child_menu.isMouseInside()==false || override_mouse==true){
					child_menu.hide()
					
					var cNode:Object = _global.config.menu_config.option
					this._parent.txt.textColor = cNode.color.off._value
					//this._parent.bg._alpha = Number(cNode.background.alpha_off._value)
					this._parent.bgColor.setRGB(Number(cNode.background.off._value))
				}
			}
			
		}else{
			//ITEM WITHOUT SUBMENU EVENTS
			var ref:MovieClip = this
			item.btarea.onRelease = function(){
				ref.selectItem(this._parent, this._parent.initObject)
			}
			item.btarea.onRollOver = function(){
				this._parent.t_item.textColor = "0x000000"
			}
			item.btarea.onRollOut = item.btarea.onReelaseOutside = function(){
				this._parent.t_item.textColor = "0x4F637B"
			}
		}
	}
	
	public function selectItem(item_clip:MovieClip, item_initObj:Object):Void {
		var menuclip:MovieClip = item_clip.getMenu()
		menuclip.selectItem(item_clip)
		
		onMenuItemSelected(item_initObj)
	}
	
	public function onMenuItemSelected(item_initobj:Object):Void {}
}