import com.wunderman.ui.IPreloader

/**
* @class 	Preloader
* @tooltip 	Manages the View of the Preloader
* @author	Federico Campo Piombi
* @version 	1.0
* @date 	03 Nov 2006
*/
class com.parker.ui.Preloader extends MovieClip implements IPreloader {
	
	//properties
	private var logo:MovieClip
	
	
	/**
	* @constructor
	*/
	public function Preloader(){}
	
	
	/**
	* @method 	setProgress
	* @tooltip 	Receives the current load's progress and displays the bar
	* @param	bL (Number) current load's BytesLoaded
	* @param	bT (Number) current load's BytesTotal
	* @return	Void
	*/
	public function setProgress(bL:Number, bT:Number):Void {
		logo.bar._yscale = Math.ceil(bL*100/bT)
	}
	
	/**
	* @method 	hide
	* @tooltip 	Hides the preloader
	* @return 	Void
	*/
	public function hide():Void {
		this._visible = false
	}
	
	/**
	* @method 	show
	* @tooltip 	Displays the preloader
	* @return 	Void
	*/
	public function show():Void {
		this._visible = true
	}
}